Bug 578290 - Review Request: mj - Mah-Jong program with network option
Summary: Review Request: mj - Mah-Jong program with network option
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Klaus Grue
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-03-30 19:14 UTC by Göran Uddeborg
Modified: 2010-09-26 04:33 UTC (History)
6 users (show)

Fixed In Version: mj-1.10-6.fc13
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-05-31 18:16:28 UTC
grue: fedora-review+
tibbs: fedora-cvs+


Attachments (Terms of Use)

Description Göran Uddeborg 2010-03-30 19:14:20 UTC
Spec URL: ftp://ftp.uddeborg.se/pub/mj/mj.spec
SRPM URL: ftp://ftp.uddeborg.se/pub/mj/mj-1.10-1.src.rpm
Description: 
This is the game of Mah-Jong, not be confused with the solitaire
matching game using the same tiles.  It is a set of three programs
which provide a networked Mah-Jong system, together with a computer
player.  Thus the game can be played by four humans, by a human and
three computer players, or any other combination.

Comment 1 Göran Uddeborg 2010-03-30 20:15:34 UTC
I should mention that if you run rpmlint on the SRPM, you will get several warnings about spelling errors in the Swedish description, referring to words from the English description.  From what I can tell, this is because of some bug in rpm, see bug 578299.

Comment 2 Göran Uddeborg 2010-04-05 16:19:05 UTC
I realized the scriptlets I used were not quite following the current packaging standards.  I've made a slightly updated version of the package to fix that:

Spec URL: ftp://ftp.uddeborg.se/pub/mj/mj.spec
SRPM URL: ftp://ftp.uddeborg.se/pub/mj/mj-1.10-2.src.rpm

Comment 3 Klaus Grue 2010-04-09 20:56:33 UTC
I have done a pre-review of the package and filed it under Bug 523715

Comment 4 Klaus Grue 2010-04-10 06:47:17 UTC
Here is the pre-review. It is my first pre-review.
M. Tasaka has promised to take a look at it.
There are quite a number of open points in it where
I don't know what to do.



I have built the source RPM for x86_64 and i386.
Running rpmlint on the binary packages causes no complaints.
Below I go through
  http://fedoraproject.org/wiki/Packaging/ReviewGuidelines
step by step (rather mechanical - sorry - but I hope that
is a reasonable way to start).

Below, "you" means "the packager".

For each comment I make below I have added one of the
following attributes after the comment:
ACTION   The packager must do or say something
QUESTION I am in doubt what to do here
OK       Selfexplanatory



MUST: rpmlint must be run on every package. The output
should be posted in the review.

> I should mention that if you run rpmlint on the SRPM,
> you will get several warnings about spelling errors
> in the Swedish description, referring to words from
> the English description.  From what I can tell, this
> is because of some bug in rpm, see bug 578299.

I only get two erros from rpmlint:

> mj.src: W: no-cleaning-of-buildroot %install
> You should clean $RPM_BUILD_ROOT in the %clean
> section and in the beginning of the %install section.
> Use "rm -rf $RPM_BUILD_ROOT". Some rpm configurations
> do this automatically; if your package is only going
> to be built in such configurations, you can ignore
> this warning for the section(s) where your rpm
> takes care of it.

> mj.src: W: no-buildroot-tag
> The BuildRoot tag isn't used in your spec. It must
> be used in order to allow building the package as
> non root on some systems. For some rpm versions (e.g.
> rpm.org >= 4.6) the BuildRoot tag is not necessary
> in specfiles and is ignored by rpmbuild; if your
> package is only going to be built with such rpm
> versions you can ignore this warning.

Could you take a look at that?

[[NOTE: "you" means the packager in the line above,
i.e. Göran Uddeborg, not Mamoru Tasaka]]

ACTION



MUST: The package must be named according to the
Package Naming Guidelines.

Naming guidelines are met.

But 'mj' is a *very* short name. There are only
26^2=676 package names which consist of two, small
letters, so I suppose such names are reserved.

The name matches the upstream tar-ball
(mj-1.10-src.tar.gz). Do you think upstream would
be willing to change name to e.g. mahjong-1.10
or mahjongg-1.10? Those names do not appear to be
taken yet. In particular, /usr/bin/mahjongg belongs
to gnome-games-2.26.3-1.fc11.x86_64.

ACTION



MUST: The spec file name must match the base package
%{name}, in the format %{name}.spec unless your
package has an exemption.

OK



MUST: The package must meet the Packaging Guidelines.

The application is written in C but uses neither
$RPM_OPT_FLAGS nor %{optflags}

ACTION

http://fedoraproject.org/wiki/Packaging/Guidelines#desktop-file-install_usage
says that one should use desktop-file-install (mj.spec does that)
and should also BuildRequire desktop-file-utils (mj.spec doesn't)

ACTION

http://fedoraproject.org/wiki/Packaging/Guidelines#.25global_preferred_over_.25define
says that you should use %global instead of %define, unless
you really need only locally defined submacros within other
macro definitions (a very rare case). mj.spec contains
two instances of %define. Is that needed?

ACTION

Consider using
  cp -p ../tiles-v1/tong* .
rather than
  cp ../tiles-v1/tong* .
c.f. http://fedoraproject.org/wiki/Packaging/Guidelines#Timestamps

ACTION



MUST: The package must be licensed with a Fedora
approved license and meet the Licensing Guidelines.

License in upstream tar file:
> The programs are distributed under the GNU General
> Public License, version 2, or at your discretion
> any later version.

Part of the upstream tar file, however, is non-GNU.
The mj.spec file says:

# The bundled tiles have a non-commercial-use license.  So instead we
# use GPL tiles from kdegames instead.  The solution was suggested by
# Tom 'spot' Callaway in:
# http://lists.fedoraproject.org/pipermail/legal/2010-February/001109.html

As mentioned in tiles-v1/README it is questionable whether or
not the bundled tiles have a non-commercial-use license. Thus
it is questionable whether or not the tiles can be GNU GPL.

Tom 'spot' Callaway says the tiles are not GNU GPL.

Using GPL tiles from kdegames as indicated above seems like a
good idea. That guarantees that the tiles used are GPL.

But then I suppose the tiles-v1/ directory should be removed from
the source package since otherwise the source package will contain
tiles which are not GNU GPL.

ACTION

The upstream .c and .h files refer to the LICENSE file for license
information except lazyfixed.c, lazyfixed.h, vlazyfixed.c, and
vlazyfixed.h which refer to
  GNU Lesser General Public License (any version).
Is that a problem?

QUESTION

In upstream .c and .h files, the author claims moral rights.
Does that have any effect? I found something here:
http://www.sun.com/software/opensource/contributor_agreement.jsp#r_3

3.
Q:
The SCA requires that I agree not to assert my "moral rights." What are moral
rights?
A:
Moral rights are additional rights of the creators of copyrighted works
recognized in some jurisdictions, and intended to protect the relationship
between an artist and his or her work. These rights remain in place even after
ownership of the work is shared or transferred. Moral rights typically only
apply to visual or artistic works, and not to utilitarian works such as
software. They may prohibit the alteration or mutilation of a work, may protect
the author's right of attribution or anonymous publication, and in general
govern the artistic integrity of a creative work. It would be unusual for moral
rights to apply to an open-source contribution, but in the event they do and
you live in a jurisdiction that recognizes moral rights, when you sign the SCA
you agree not to assert them with respect to your contributions.

QUESTION



MUST: The License field in the package spec file must
match the actual license.

Spec file license:
> License:     GPLv2+

OK



MUST: If (and only if) the source package includes the text of the license(s)
in its own file, then that file, containing the text of the license(s) for the
package must be included in %doc.

File LICENSE is included in %doc

OK



MUST: The spec file must be written in American English.

It is. Description and summary are provided in Swedish also.
The Swedish description and summary matches the American
English ones.

OK



MUST: The spec file for the package MUST be legible.

It is.

OK



MUST: The sources used to build the package must match the upstream source, as
provided in the spec URL. Reviewers should use md5sum for this task. If no
upstream URL can be specified for this package, please see the Source URL
Guidelines for how to deal with this.

Downloaded from
http://mahjong.julianbradfield.org/Source/mj-1.10-src.tar.gz:
f9bacf9fd6743d5e3a2fd86863607ce2  mj-1.10-src.tar.gz

In source rpm:
f9bacf9fd6743d5e3a2fd86863607ce2  mj-1.10-src.tar.gz

OK



MUST: The package MUST successfully compile and build into binary rpms on at
least one primary architecture.

Compiles and builds successfully for fc11/x86_64 and fc11/i586.

OK



MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line.

I am unable to test PPC. What shall I do?

QUESTION



MUST: All build dependencies must be listed in BuildRequires, except for any
that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.

Must be OK since it builds in a chroot jail using mock.

OK



MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

The spec file does not handle locales at all.

OK



MUST: Every binary RPM package (or subpackage) which stores shared library
files (not just symlinks) in any of the dynamic linker's default paths, must
call ldconfig in %post and %postun.

The RPM package defines no shared libraries.

OK



MUST: Packages must NOT bundle copies of system libraries.

OK



MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker. [12]

%prep replaces non-GNU-GPL tiles with tiles found at
/usr/share/kde4/apps/kmahjongglib/tilesets/default.svgz
Apart from that, /usr is neither hardcoded in mj.spec
nor in the Makefiles.

OK



MUST: A package must own all directories that it creates. If it does not create
a directory that it uses, then it should require a package which does create
that directory.

The package uses these directories without creating them:

Directory                            Owner

/usr/bin/                            filesystem-2.4.21-1.fc11.x86_64
/usr/share/applications/             filesystem-2.4.21-1.fc11.x86_64
/usr/share/doc/                      filesystem-2.4.21-1.fc11.x86_64
/usr/share/icons/hicolor/32x32/apps/ hicolor-icon-theme-0.10-6.noarch
/usr/share/man/man1/                 policycoreutils-2.0.62-12.14.fc11.x86_64

How can I find out if one needs to require
hicolor-icon-theme-0.10-6.noarch and
policycoreutils-2.0.62-12.14.fc11.x86_64 ?

QUESTION



MUST: A Fedora package must not list a file more than once in the spec file's
%files listings.

OK



MUST: Permissions on files must be set properly. Executables should be set with
executable permissions, for example. Every %files section must include a
%defattr(...) line.

rpm -qlv mj
-rwxr-xr-x root root /usr/bin/mj-player
-rwxr-xr-x root root /usr/bin/mj-server
-rwxr-xr-x root root /usr/bin/xmj
-rw-r--r-- root root /usr/share/applications/mj.desktop
drwxr-xr-x root root /usr/share/doc/mj-1.10
-rw-r--r-- root root /usr/share/doc/mj-1.10/CHANGES
-rw-r--r-- root root /usr/share/doc/mj-1.10/ChangeLog
-rw-r--r-- root root /usr/share/doc/mj-1.10/LICENCE
-rw-r--r-- root root /usr/share/doc/mj-1.10/README
-rw-r--r-- root root /usr/share/doc/mj-1.10/rules.txt
-rw-r--r-- root root /usr/share/doc/mj-1.10/use.txt
-rw-r--r-- root root /usr/share/icons/hicolor/32x32/apps/mj.png
-r--r--r-- root root /usr/share/man/man1/mj-player.1.gz
-r--r--r-- root root /usr/share/man/man1/mj-server.1.gz
-r--r--r-- root root /usr/share/man/man1/xmj.1.gz

Why are man pages not user writable?

ACTION



MUST: Each package must consistently use macros.

As far as I can see, mj.spec uses macros consistently.
Is that what is asked for here? Is there something
particular to look for?

Is this a question of using either $RPM_OPT_FLAGS
or %{optflags}? In that case, mj.spec uses the
%{optflags} style consistently and '$RPM' does not
occur anywhere in mj.spec.

QUESTION



MUST: The package must contain code, or permissable content.

OK



MUST: Large documentation files must go in a -doc subpackage. (The definition
of large is left up to the packager's best judgement, but is not restricted to
size. Large can refer to either size or quantity).

Documentation consists of
25653 bytes rules.txt
41244 bytes use.txt
22311 bytes xmj.1.gz

OK



MUST: If a package includes something as %doc, it must not affect the runtime
of the application. To summarize: If it is in %doc, the program must run
properly if it is not present.

OK



MUST: Header files must be in a -devel package.

The package installs no .h files.

OK



MUST: Static libraries must be in a -static package.

The package installs no static libraries.

OK



MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1),
then library files that end in .so (without suffix) must go in a -devel
package.

The package installs no .so files.

OK



MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release}

OK



MUST: Packages must NOT contain any .la libtool archives, these must be removed
in the spec if they are built.

OK



MUST: Packages containing GUI applications must include a %{name}.desktop file,
and that file must be properly installed with desktop-file-install in the
%install section. If you feel that your packaged GUI application does not need
a .desktop file, you must put a comment in the spec file with your explanation.

OK



MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the filesystem or man package. If you
feel that you have a good reason to own a file or directory that another
package owns, then please present that at package review time.

OK



MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}
(or $RPM_BUILD_ROOT).

It does not. As mentioned previously, rpmlint complains about it.

ACTION



MUST: All filenames in rpm packages must be valid UTF-8.

OK



SHOULD: If the source package does not include license text(s) as a separate
file from upstream, the packager SHOULD query upstream to include it.

The source package has a LICENSE file. The LICENSE file contains
license info followed by the GNU GPL license.

OK



SHOULD: The description and summary sections in the package spec file should
contain translations for supported Non-English languages, if available.

Description and summary is available in English and Swedish. The Mahjong
program itself seems to support English only.

OK



SHOULD: The reviewer should test that the package builds in mock.

Done for x86_64 and i386.

OK



SHOULD: The package should compile and build into binary rpms on all supported
architectures.

I cannot test PPC.

QUESTION



SHOULD: The reviewer should test that the package functions as described. A
package should not segfault instead of running, for example.

The x86_64 version seems to run fine.

OK



SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague,
and left up to the reviewers judgement to determine sanity.

OK



SHOULD: Usually, subpackages other than devel should require the base package
using a fully versioned dependency.

There are no subpackages.

OK



SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and
this is usually for development purposes, so should be placed in a -devel pkg.
A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb.

There are no such files.

OK



SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself.

The package only BuildRequire packages.

OK



SHOULD: your package should contain man pages for binaries/scripts. If it
doesn't, work with upstream to add them where they make sense.

Man pages are included for all three binaries (xmj, mj-player, and mj-server).

OK

Comment 5 Mamoru TASAKA 2010-04-10 17:44:59 UTC
Hi, spot:

Many source codes contain:
/****************** COPYRIGHT STATEMENT **********************
 * This file is Copyright (c) 2000 by J. C. Bradfield.       *
 * Distribution and use is governed by the LICENCE file that *
 * accompanies this file.                                    *
 * The moral rights of the author are asserted.              *
 *                                                           *

What does "the moral rights" mean?

Comment 6 Göran Uddeborg 2010-04-10 18:01:57 UTC
Thanks a lot for your review, or pre-review strictly speaking.  This is only my second package for Fedora so I'm new at this myself.

> I only get two errors from rpmlint:

> > mj.src: W: no-cleaning-of-buildroot %install

> > mj.src: W: no-buildroot-tag

> Could you take a look at that?

As I understand it, none of these have been needed since F-10 (https://fedoraproject.org/wiki/Packaging:Guidelines#BuildRoot_tag).  I'm only planning to ask for this to be released for F-13.  Thinking about it, that actually means I could simplify a bit more, and remove the %clean section too.

> 'mj' is a *very* short name.

> Do you think upstream would
> be willing to change name to e.g. mahjong-1.10
> or mahjongg-1.10?

It is indeed short.  It will hardly hurt to discuss it with upstreams.  I'll send him a letter and ask.

Including a version number to distinguish two completely different programs like Mah-Jong from mj and the solitaire Mah-Jong from gnome-games might not be ideal.  Version numbers in command names are typically used when you explicitly want to use a particular version, like for automake and python.

Until upstreams changes, I guess the rules from the naming guidelines about following upstreams prevail and I keep the name?  Or should I change the naming specifically for Fedora?

> The application is written in C but uses neither
> $RPM_OPT_FLAGS nor %{optflags}

Ah!  Forgot that!  Thanks, I'll fix.

> … should also BuildRequire desktop-file-utils (mj.spec doesn't)

It's indirectly required.  But it's probably better do require it explicitly.  I'll add it.

> mj.spec contains
> two instances of %define. Is that needed?

Nope, old habits die hard.  I'll fix it.

> Consider using
>   cp -p ../tiles-v1/tong* .

Good point, I will.

> But then I suppose the tiles-v1/ directory should be removed from
> the source package since otherwise the source package will contain
> tiles which are not GNU GPL.

Are you saying I should modify the tar file?  I thought that was something we didn't do.  And since I don't actually *use* the restricted tiles, they are not part of the binary package, I thought this was ok.

But I may be wrong.  Should I bother fedora-legal once more about this, maybe?

> … except lazyfixed.c, lazyfixed.h, vlazyfixed.c, and
> vlazyfixed.h which refer to
>   GNU Lesser General Public License (any version).
> Is that a problem?

Obviously not for distributability.  Reading the first answer of https://fedoraproject.org/wiki/Licensing/FAQ#How_should_I_handle_multiple_licensing_situations.3F I believe that the license tag should only say the stricter license (GPL) in this case.  Do you agree?  Or should I ask fedora-legal about this (too)?

> … the author claims moral rights.
> Does that have any effect?

I can't imagine how it could make a difference if the author "asserts" a right he can't surrender anyway.  But I see that Mamoru Tasaka has already brought that up with Fedora Legal while I was writing this reply, wo I guess we will have an answer.

> I am unable to test PPC. What shall I do?

I *expect* it to build on PPC.  Later when I can start builds via koji, I can verify that it indeed does.  If there is a way to verify earlier, I would like to know just as much as you.

> How can I find out if one needs to require
> hicolor-icon-theme-0.10-6.noarch and
> policycoreutils-2.0.62-12.14.fc11.x86_64 ?

/usr/share/man/man1 is owned by filesystem too, so policycoreutils should not be needed.

There seems to be plenty of packages that places things in /usr/share/icons/hicolor/32x32/apps/, but much fewer require hicolor-icon-theme.  So I guess it's default.  But maybe all those packages should have required it?

> Why are man pages not user writable?

It's an upstreams decision.  The Makefile.in in the tar file sets them to read-only for all.  Is this something I should change as packager?  Is there any rule that files like man pages should be user writable?  There are rules that the permissions should be set "properly".  But it's not clear to me that r--r--r-- is less proper than rw-r--r-- for a manual page.  Do I miss something?

I've made an updated version including those things that were clear:

SPEC: ftp://ftp.uddeborg.se/pub/mj/mj.spec
SRPM: ftp://ftp.uddeborg.se/pub/mj/mj-1.10-3.fc13.src.rpm

Comment 7 Göran Uddeborg 2010-04-10 20:59:35 UTC
I got a prompt reply from Julian Bradfield, the upstreams maintainer.  Essentially, he says that if he were to start over, he would probably call the package something like mah-jong.  But he doesn't want to impose a name change on the current user base.  In particular since the package is only maintained now, not further developed.

I believe the best thing is to follow the general rule from the naming guidelines and use the same name as the upstreams package.  After all, this is not the only package with a two-letter name in Fedora.

Comment 8 Göran Uddeborg 2010-04-10 21:01:58 UTC
> What does "the moral rights" mean?

Wikipedia can explain what it *means*: http://en.wikipedia.org/wiki/Moral_rights_%28copyright_law%29

I'll leave to Fedora Legal to clarify if this statement in the code is a *problem* in any way.  I believe not, but IANAL.

Comment 9 Klaus Grue 2010-04-10 21:40:05 UTC
I will return as soon as possible. Just a few short notes.

---

> > > mj.src: W: no-cleaning-of-buildroot %install
> > > mj.src: W: no-buildroot-tag
> > Could you take a look at that?
> As I understand it, none of these have been needed since F-10
I agree. One should probably ignore rpmlint here.

---

> I believe the best thing is to follow the general rule from the naming
> guidelines and use the same name as the upstreams package.

I agree. It is fortunate that 'mj' is not taken (as far as I have been
able to see).

---

> I can't imagine how it could make a difference if the author
> "asserts" a right he can't surrender anyway.

Julian Bradfield lives in Edinburgh (UK). So I think this applies:

> It is important to note that authors or creators must choose
> to assert their Moral Rights (they are not automatic as
> copyright is), but at the same time, Moral Rights can never
> be assigned - they remain with the author even if he or she
> assigned the copyright to a publisher or some other organisation.

So I think Julian Bradfield knows exactly what he does. I agree
there would be no point in asserting moral rights in Scandinavia.

---

> > Why are man pages not user writable?
> It's an upstreams decision.
OK. As long as man pages are uninstallable, it must be OK that
they are not writable.

Comment 10 Klaus Grue 2010-04-11 15:26:10 UTC
Just one more quick note. mj builds fine on PPC and PPC64:
https://koji.fedoraproject.org/koji/taskinfo?taskID=2108393
I return later.

Comment 11 Klaus Grue 2010-04-12 09:17:46 UTC
Now I have looked at mj-1.10-3.

There are NO remaining actions for the packager (Göran Uddeborg)
as far as I can see.

We wait for one answer from Tom 'spot' Callaway on "moral rights".

I have three questions to Mamoru Tasaka:

Is it ok to include non-GPL tiles in the source package
when the non-GPL tiles are not included in the binary packages?
I suppose I should ask Tom 'spot' Callaway about that, but
how should I do that? By a direct e-mail to him with a copy
on the present page?

The package uses the directory /usr/share/icons/hicolor/32x32/apps/
which is owned by package hicolor-icon-theme-0.10-6.noarch. How
can I know whether or not one needs to require
hicolor-icon-theme-0.10-6.noarch?

Packaging guidelines says that "Each package must consistently
use macros." Is this a question of using either $RPM_OPT_FLAGS
style or %{optflags} style?

---

Comments on mj-1.10-3

Doing a diff of mj-1.10-2 and mj-1.10-3 one can see that
things like "#FFFFF0" have changed to things like "ivory"
many places in the tiles-kdegames. I assume that is a
consequence of some change in kgegames and should not be
mentioned in the mj changelog.

OK



> > > Why are man pages not user writable?
> > It's an upstreams decision.
> OK. As long as man pages are uninstallable, it must be OK that
> they are not writable.    
PS. I meant "As long as man pages can be uninstalled..."
I have checked installing and erasing the package and the
man pages appear and disappear as they should.

OK



> > ... except lazyfixed.c, lazyfixed.h, vlazyfixed.c, and
> > vlazyfixed.h which refer to
> >   GNU Lesser General Public License (any version).
> > Is that a problem?
> 
> Obviously not for distributability.  Reading the first answer of
> https://fedoraproject.org/wiki/Licensing/FAQ#How_should_I_handle_multiple_licensing_situations.3F
> I believe that the license tag should only say the stricter license (GPL) in
> this case.  Do you agree?  Or should I ask fedora-legal about this (too)?

I agree. OK.

Comment 12 Tom "spot" Callaway 2010-04-19 17:05:19 UTC
The author asserting his "moral rights" is not a problem. As was pointed out, he cannot actually waive them in his legal jurisdiction. :)

Lifting FE-Legal.

Comment 13 Mamoru TASAKA 2010-04-19 17:54:43 UTC
spot, thank you for auditing this.

(In reply to comment #11)
> Is it ok to include non-GPL tiles in the source package
> when the non-GPL tiles are not included in the binary packages?
> I suppose I should ask Tom 'spot' Callaway about that, but
> how should I do that? By a direct e-mail to him with a copy
> on the present page?

- As the license of the tiles is legally forbidden on Fedora,
  these files should also be removed from the source tarball
  itself. Please refer to
  https://fedoraproject.org/wiki/Packaging/SourceURL#When_Upstream_uses_Prohibited_Code

> The package uses the directory /usr/share/icons/hicolor/32x32/apps/
> which is owned by package hicolor-icon-theme-0.10-6.noarch. How
> can I know whether or not one needs to require
> hicolor-icon-theme-0.10-6.noarch?

- Usually for gtk2-dependent packages we don't add "R: hicolor-icon-theme"
  explicitly because gtk2 already has this dependency.

> Packaging guidelines says that "Each package must consistently
> use macros." Is this a question of using either $RPM_OPT_FLAGS
> style or %{optflags} style?
- I usually interpret this like:
  * Once a macro is defined by in the spec explicitly, the packager
    should always use the macro where the macro can be used.
    For this package, as %icondir is explicitly defined,
    "/usr/share/icons/hicolor/32x32/apps" should always be replaced
    by %icondir.
  * Also when some already-defined macros can be used, we should
    use such macros as much as possible.
  * A packager should not use both %optflags and $RPM_OPT_FLAGS but
    choose one.

To Klaus:
As you are sponsored, you can formally review this. Would you
want to do so?

Comment 14 Klaus Grue 2010-04-19 19:06:25 UTC
Tasaka> To Klaus:
Tasaka> As you are sponsored, you can formally review this. Would you
Tasaka> want to do so?

I will try to take it from here. Thanks for your help.

Now I think only two issues remain:

As Mamoru Tasaka mentioned, the non-GPL tiles must be removed:
https://fedoraproject.org/wiki/Packaging/SourceURL#When_Upstream_uses_Prohibited_Code

When I read the spec again for consistent use of macros, this caught my eye:
  %files
  ...
  %_bindir/*
  %_mandir/man1/*
I suppose those lines say that mj owns everything in bin and man1.

Comment 15 Göran Uddeborg 2010-04-20 20:58:43 UTC
Thanks for your comments.  I'll make an updated version without the non-GPL tiles in a couple of days.  In the mean time, a few short comments.

> The Swedish description and summary matches the American
> English ones.

Nice with a reviewer able to verify that! :-)  Would you like to have a Danish version included too?

> ... one can see that
> things like "#FFFFF0" have changed to things like "ivory"
> many places in the tiles-kdegames. I assume that is a
> consequence of some change in kgegames ...

It could also be a packager being bad in keeping the change log up to date.  :-)

I'll add a note.

>  %_bindir/*
>  %_mandir/man1/*
> I suppose those lines say that mj owns everything in bin and man1.

Yes, that's correct, it does.  I don't quite understand what you mean the issue is though.  Do you find it more pretty to explicitly list the three files in each directory?  I don't have any strong opinion, I could do either way.  Or do you mean something else?  How should I understand your comment?

Comment 16 Klaus Grue 2010-04-21 11:43:18 UTC
> >  %_bindir/*
> >  %_mandir/man1/*
> > I suppose those lines say that mj owns everything in bin and man1.

> Yes, that's correct, it does.  I don't quite understand what you
> mean the issue is though.

OK. It seems there is no issue. RPM seems to be sensible:

> su
> touch /usr/bin/foo
> rpm -qf /usr/bin/foo
file /usr/bin/foo is not owned by any package
> rpm -i mj-1.10-3.fc13.x86_64.rpm 
> rpm -qf /usr/bin/foo
file /usr/bin/foo is not owned by any package
> rpm -e mj
> rpm -qf /usr/bin/foo
file /usr/bin/foo is not owned by any package

So mj does not claim ownership of /usr/bin/foo and does not erase it
at uninstall.

So it is probably OK to use %_bindir/* and %_mandir/man1/*

---

> Would you like to have a Danish version included too?

That would be nice:-) But no, I think it has a cost in maintenance which is
not worth paying. Having the Swedish version is nice.

Comment 17 Göran Uddeborg 2010-04-21 21:28:36 UTC
Ah, now I understand the confusion!

When one states a pattern like %_bindir/* in the files section, the pattern gets expanded at packaging time.  So it expands to everything that is installed in the %_bindir in the buildroot created during %install.

The created package only owns the expanded values, not the patterns as such.  You see the result if you do "rpm -ql" (or "rpm -qlp" before installation) on it.  What you see then are the values actually stored in the package.

Comment 18 Göran Uddeborg 2010-04-22 21:17:47 UTC
Here's my next try:

SPEC: ftp://ftp.uddeborg.se/pub/mj/mj.spec
SRPM: ftp://ftp.uddeborg.se/pub/mj/mj-1.10-4.fc13.src.rpm

It contains a version of the tar file only including GPL sources.  A simple script inspired by the wiki example is also included.

Comment 19 Klaus Grue 2010-04-28 08:22:55 UTC
> Here's my next try ...

Perfect. Sorry for not responding before.

As a new packager, I do not know if I can approve your package,
but as far as I am concerned:

---------------------------------------------
    This package (mj) is APPROVED by grue
---------------------------------------------

http://fedoraproject.org/wiki/PackageMaintainers/Join#Get_Sponsored says:

Review and approval for the first package for new packagers must be done by registered sponsors. Subsequent reviews can be done by any package maintainer. Informal reviews can always be done by anyone interested.

http://fedoraproject.org/wiki/PackageMaintainers/Join#Get_Sponsored also says:

When the package is approved by the reviewer, you must separately obtain member sponsorship in order to check in and build your package.

I do not really know what you (or I) should do from here. But I suppose next step will be you find a sponsor.

Comment 20 Mamoru TASAKA 2010-04-28 08:31:44 UTC
Klaus:

Göran is already in fedora packager's group and already has
a sponsor, so if you think this package can be approved,
you can set fedora-review flag to +.

Comment 21 Klaus Grue 2010-04-28 10:16:36 UTC
> Göran is already in fedora packager's group and already has
> a sponsor, so if you think this package can be approved,
> you can set fedora-review flag to +.

OK. Thanks. Done.

Comment 22 Göran Uddeborg 2010-04-28 21:04:17 UTC
That's correct, I'm already a seasoned packager with a total of one previous package in Fedora. :-)

Seriously, thanks a lot for all your comments!  Time to request a CVS module.

New Package CVS Request
=======================
Package Name: mj
Short Description: Mah-Jong program with network option
Owners: goeran
Branches: F-13
InitialCC:

Comment 23 Jason Tibbitts 2010-04-29 02:12:00 UTC
CVS done (by process-cvs-requests.py).

Comment 24 Fedora Update System 2010-05-01 17:11:42 UTC
mj-1.10-4.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/mj-1.10-4.fc13

Comment 25 Chen Lei 2010-05-01 17:35:51 UTC
The debug subpackage is empty, please fix it.
e.g.
make install STRIP=/bin/true

http://fedoraproject.org/wiki/Packaging:Debuginfo#Useless_or_incomplete_debuginfo_packages_due_to_packaging_issues

Comment 26 Göran Uddeborg 2010-05-01 20:35:14 UTC
Bother!  Missed that.

I'll fix it.

Comment 27 Fedora Update System 2010-05-02 09:39:22 UTC
mj-1.10-5.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/mj-1.10-5.fc13

Comment 28 Fedora Update System 2010-05-04 06:13:11 UTC
mj-1.10-5.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update mj'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/mj-1.10-5.fc13

Comment 29 Fedora Update System 2010-05-31 18:16:18 UTC
mj-1.10-5.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 30 Fedora Update System 2010-09-13 19:51:39 UTC
mj-1.10-6.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/mj-1.10-6.fc13

Comment 31 Fedora Update System 2010-09-26 04:33:08 UTC
mj-1.10-6.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.